(*
Author: Robert Sison
Based on the Dependent_SIFUM_(Refinement|Type_Systems) AFP entries, whose authors are:
  Toby Murray, Robert Sison, Edward Pierzchalski, Christine Rizkallah
Dependent_SIFUM_Type_Systems was based on the SIFUM_Type_Systems AFP entry, whose authors are:
  Sylvia Grewe, Heiko Mantel, Daniel Schoepe
*)

theory ITP19PaperDefs
imports "old-rg-sec/Security"
        "refinement/CompositionalRefinement"
begin

context sifum_security_init begin

definition 
  low_mds_eq_lc_specific :: "'Var Mds \<Rightarrow> (('Com, 'Var, 'Val) LocalConf) \<Rightarrow> (('Com, 'Var, 'Val) LocalConf) \<Rightarrow> bool"
  ("_ =\<index>\<^sup>l\<^sup>c _" [100, 100] 80)
where
  "(lc\<^sub>1 =\<^bsub>mds\<^esub>\<^sup>l\<^sup>c lc\<^sub>2) \<equiv> snd (fst lc\<^sub>1) = mds \<and> snd (fst lc\<^sub>2) = mds \<and> low_mds_eq mds (snd lc\<^sub>1) (snd lc\<^sub>2)"

definition 
  lc_low_mds_eq :: "(('Com, 'Var, 'Val) LocalConf) \<Rightarrow> (('Com, 'Var, 'Val) LocalConf) \<Rightarrow> bool"
  ("_ =\<^sub>m\<^sub>d\<^sub>s\<^sup>l _" [100, 100] 80)
where
  "(lc\<^sub>1 =\<^sub>m\<^sub>d\<^sub>s\<^sup>l lc\<^sub>2) \<equiv> snd (fst lc\<^sub>1) = snd (fst lc\<^sub>2) \<and> low_mds_eq (snd (fst lc\<^sub>2)) (snd lc\<^sub>1) (snd lc\<^sub>2)"

definition 
  lc_same_mds :: "(('Com, 'Var, 'Val) LocalConf) \<Rightarrow> (('Com, 'Var, 'Val) LocalConf) \<Rightarrow> bool"
  ("_ =\<^sub>m\<^sub>d\<^sub>s _" [100, 100] 80)
where
  "(lc\<^sub>1 =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2) \<equiv> snd (fst lc\<^sub>1) = snd (fst lc\<^sub>2)"

definition 
  lc_same_mds_mem :: "(('Com, 'Var, 'Val) LocalConf) \<Rightarrow> (('Com, 'Var, 'Val) LocalConf) \<Rightarrow> bool"
  ("_ =\<^sub>m\<^sub>d\<^sub>s\<^sup>m _" [100, 100] 80)
where
  "(lc\<^sub>1 =\<^sub>m\<^sub>d\<^sub>s\<^sup>m lc\<^sub>2) \<equiv> snd (fst lc\<^sub>1) = snd (fst lc\<^sub>2) \<and> snd lc\<^sub>1 = snd lc\<^sub>2"

definition 
  closed_glob_consistent_paper1 :: "(('Com, 'Var, 'Val) LocalConf) rel \<Rightarrow> bool"
where
  "closed_glob_consistent_paper1 \<R> =
  (\<forall> c\<^sub>1 mds mem\<^sub>1 c\<^sub>2 mem\<^sub>2. (\<langle> c\<^sub>1, mds, mem\<^sub>1 \<rangle>, \<langle> c\<^sub>2, mds, mem\<^sub>2 \<rangle>) \<in> \<R> \<longrightarrow>
   (\<forall> mem\<^sub>1' mem\<^sub>2'. ((\<forall>x. (mem\<^sub>1 x \<noteq> mem\<^sub>1' x \<or> mem\<^sub>2 x \<noteq> mem\<^sub>2' x) \<longrightarrow> \<not> var_asm_not_written mds x) \<and>
          (\<forall>x. dma mem\<^sub>1' x \<noteq> dma mem\<^sub>1 x \<longrightarrow> \<not> var_asm_not_written mds x) \<and>
          (\<forall>x. dma mem\<^sub>1' x = Low \<and> (x \<notin> mds AsmNoReadOrWrite \<or> x \<in> \<C>) \<longrightarrow> mem\<^sub>1' x = mem\<^sub>2' x)) \<longrightarrow>
         (\<langle> c\<^sub>1, mds, mem\<^sub>1' \<rangle>, \<langle> c\<^sub>2, mds, mem\<^sub>2' \<rangle>) \<in> \<R>))"

lemma cg_consistent_paper1:
  "closed_glob_consistent = closed_glob_consistent_paper1"
  apply(rule ext)
  unfolding closed_glob_consistent_def closed_glob_consistent_paper1_def
  apply clarsimp
  apply(rename_tac \<R>)
  apply(rule iffI)
   apply clarsimp
   apply(erule_tac x=c\<^sub>1 in allE)
   apply(erule_tac x=mds in allE)
   apply(erule_tac x=mem\<^sub>1 in allE)
   apply(erule_tac x=c\<^sub>2 in allE)
   apply(erule_tac x=mem\<^sub>2 in allE)
   apply clarsimp
   apply(erule_tac x="\<lambda> y. if mem\<^sub>1' y = mem\<^sub>1 y \<and> mem\<^sub>2' y = mem\<^sub>2 y then None else Some (mem\<^sub>1' y, mem\<^sub>2' y)" in allE)
   apply(clarsimp split:if_splits)
   apply(clarsimp simp:apply_adaptation_def split:if_splits)
   apply(erule impE)
    apply(rule conjI)
     apply clarsimp
     apply(smt case_prod_conv dma_\<C>_vars option.simps(4) option.simps(5))
    apply clarsimp
    apply(smt case_prod_conv dma_\<C>_vars option.simps(4) option.simps(5))
   apply(erule Set.set_insert)
   apply clarsimp
   apply(erule disjE)
    apply(force dest:fun_cong split:if_splits)
   apply(erule Set.set_insert)
   apply clarsimp
   apply auto[1]
  apply clarsimp
  apply(erule_tac x=c\<^sub>1 in allE)
  apply(erule_tac x=mds in allE)
  apply(erule_tac x=mem\<^sub>1 in allE)
  apply(erule_tac x=c\<^sub>2 in allE)
  apply(erule_tac x=mem\<^sub>2 in allE)
  apply clarsimp
  apply(erule_tac x="mem\<^sub>1 [\<parallel>\<^sub>1 A]" in allE)
  apply(erule_tac x="mem\<^sub>2 [\<parallel>\<^sub>2 A]" in allE)
  apply clarsimp
  apply(clarsimp simp:apply_adaptation_def split:if_splits)
  by (smt case_prodE case_prod_conv option.case_eq_if)

definition 
  closed_glob_consistent_paper2 :: "(('Com, 'Var, 'Val) LocalConf) rel \<Rightarrow> bool"
where
  "closed_glob_consistent_paper2 \<R> \<equiv>
   \<forall> tps\<^sub>1 mds mem\<^sub>1 tps\<^sub>2 mem\<^sub>2. (\<langle> tps\<^sub>1, mds, mem\<^sub>1 \<rangle>, \<langle> tps\<^sub>2, mds, mem\<^sub>2 \<rangle>) \<in> \<R> \<longrightarrow>
   (\<forall> mem\<^sub>1' mem\<^sub>2'. (\<forall>x. (mem\<^sub>1 x \<noteq> mem\<^sub>1' x \<or> mem\<^sub>2 x \<noteq> mem\<^sub>2' x \<or>
         dma mem\<^sub>1' x \<noteq> dma mem\<^sub>1 x) \<longrightarrow> \<not> var_asm_not_written mds x) \<and> low_mds_eq mds mem\<^sub>1' mem\<^sub>2' \<longrightarrow>
         (\<langle> tps\<^sub>1, mds, mem\<^sub>1' \<rangle>, \<langle> tps\<^sub>2, mds, mem\<^sub>2' \<rangle>) \<in> \<R>)"

(* Definition 1: Low-equivalent memory modulo modes *)

definition 
  low_mds_eq_paper :: "'Var Mds \<Rightarrow> ('Var, 'Val) Mem \<Rightarrow> (_, _) Mem \<Rightarrow> bool"
where
  "low_mds_eq_paper mds mem\<^sub>1 mem\<^sub>2 \<equiv> \<forall> x. x \<in> \<C> \<or> dma mem\<^sub>1 x = Low \<and> x \<notin> mds AsmNoReadOrWrite \<longrightarrow> mem\<^sub>1 x = mem\<^sub>2 x"

lemma "low_mds_eq = low_mds_eq_paper"
  unfolding low_mds_eq_def low_mds_eq_paper_def
  using \<C>_Low
  by blast

lemma cg_consistent_paper1_paper2:
  "closed_glob_consistent_paper1 = closed_glob_consistent_paper2"
  unfolding closed_glob_consistent_paper1_def closed_glob_consistent_paper2_def low_mds_eq_def
  by blast

(* Strong low bisimulations modulo modes *)
definition 
  strong_low_bisim_mm_paper :: "(('Com, 'Var, 'Val) LocalConf) rel \<Rightarrow> bool"
where
  "strong_low_bisim_mm_paper \<B> \<equiv> closed_glob_consistent \<B> \<and> sym \<B> \<and>
  (\<forall> lc\<^sub>1 lc\<^sub>2. (lc\<^sub>1, lc\<^sub>2) \<in> \<B> \<and> lc\<^sub>1 =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2 \<longrightarrow> lc\<^sub>1 =\<^sub>m\<^sub>d\<^sub>s\<^sup>l lc\<^sub>2 \<and>
    (\<forall> lc\<^sub>1'. lc\<^sub>1 \<leadsto> lc\<^sub>1' \<longrightarrow> (\<exists> lc\<^sub>2'. lc\<^sub>2 \<leadsto> lc\<^sub>2' \<and> lc\<^sub>1' =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2' \<and> (lc\<^sub>1', lc\<^sub>2') \<in> \<B>)))"

lemma "strong_low_bisim_mm = strong_low_bisim_mm_paper"
  unfolding strong_low_bisim_mm_def strong_low_bisim_mm_paper_def lc_low_mds_eq_def lc_same_mds_def
  by force

(* Definition 2: Per-thread compositional CVDNI property *)

thm com_sifum_secure_def

(* Definition 3: Closedness under globally consistent changes *)

definition 
  closed_glob_consistent_paper :: "(('Com, 'Var, 'Val) LocalConf) rel \<Rightarrow> bool"
where
  "closed_glob_consistent_paper \<R> \<equiv>
   \<forall> tps\<^sub>1 mds mem\<^sub>1 tps\<^sub>2 mem\<^sub>2. (\<langle> tps\<^sub>1, mds, mem\<^sub>1 \<rangle>, \<langle> tps\<^sub>2, mds, mem\<^sub>2 \<rangle>) \<in> \<R> \<longrightarrow>
   (\<forall> mem\<^sub>1' mem\<^sub>2'. (\<forall>x. (mem\<^sub>1 x \<noteq> mem\<^sub>1' x \<or> mem\<^sub>2 x \<noteq> mem\<^sub>2' x \<or>
         dma mem\<^sub>1 x \<noteq> dma mem\<^sub>1' x) \<longrightarrow> \<not> var_asm_not_written mds x) \<and> low_mds_eq mds mem\<^sub>1' mem\<^sub>2' \<longrightarrow>
         (\<langle> tps\<^sub>1, mds, mem\<^sub>1' \<rangle>, \<langle> tps\<^sub>2, mds, mem\<^sub>2' \<rangle>) \<in> \<R>)"

lemma cg_consistent_paper2_paper:
  "closed_glob_consistent_paper2 = closed_glob_consistent_paper"
  apply(rule ext)
  unfolding closed_glob_consistent_paper2_def closed_glob_consistent_paper_def low_mds_eq_def
    apply clarsimp
  apply(rename_tac \<R>)
  apply(rule iffI)
   apply clarsimp
   apply(erule_tac x=tps\<^sub>1 in allE)
   apply(erule_tac x=mds in allE)
   apply(erule_tac x=mem\<^sub>1 in allE)
   apply(erule_tac x=tps\<^sub>2 in allE)
   apply(erule_tac x=mem\<^sub>2 in allE)
   apply metis
  apply clarsimp
  apply(erule_tac x=tps\<^sub>1 in allE)
  apply(erule_tac x=mds in allE)
  apply(erule_tac x=mem\<^sub>1 in allE)
  apply(erule_tac x=tps\<^sub>2 in allE)
  apply(erule_tac x=mem\<^sub>2 in allE)
  by metis

lemma "closed_glob_consistent = closed_glob_consistent_paper"
  using cg_consistent_paper1 cg_consistent_paper1_paper2 cg_consistent_paper2_paper
  by simp

end

context sifum_refinement_init
begin

definition
  coupling_inv_pres_original
where
  "coupling_inv_pres_original \<R>\<^sub>A \<R> P \<equiv>
  (\<forall> c\<^sub>1\<^sub>A mds\<^sub>A mem\<^sub>1\<^sub>A c\<^sub>1\<^sub>C mds\<^sub>C mem\<^sub>1\<^sub>C. 
   (\<langle> c\<^sub>1\<^sub>A, mds\<^sub>A, mem\<^sub>1\<^sub>A \<rangle>\<^sub>A, \<langle> c\<^sub>1\<^sub>C, mds\<^sub>C, mem\<^sub>1\<^sub>C \<rangle>\<^sub>C) \<in> \<R> \<longrightarrow>
    (\<forall> c\<^sub>1\<^sub>C' mds\<^sub>C' mem\<^sub>1\<^sub>C'. \<langle> c\<^sub>1\<^sub>C, mds\<^sub>C, mem\<^sub>1\<^sub>C \<rangle>\<^sub>C \<leadsto>\<^sub>C \<langle> c\<^sub>1\<^sub>C', mds\<^sub>C', mem\<^sub>1\<^sub>C' \<rangle>\<^sub>C \<longrightarrow>
     (\<exists> n c\<^sub>1\<^sub>A' mds\<^sub>A' mem\<^sub>1\<^sub>A'. abs.neval \<langle> c\<^sub>1\<^sub>A, mds\<^sub>A, mem\<^sub>1\<^sub>A \<rangle>\<^sub>A n \<langle> c\<^sub>1\<^sub>A', mds\<^sub>A', mem\<^sub>1\<^sub>A' \<rangle>\<^sub>A \<and>
                   (\<langle> c\<^sub>1\<^sub>A', mds\<^sub>A', mem\<^sub>1\<^sub>A' \<rangle>\<^sub>A, \<langle> c\<^sub>1\<^sub>C', mds\<^sub>C', mem\<^sub>1\<^sub>C' \<rangle>\<^sub>C) \<in> \<R> \<and>
       (\<forall>c\<^sub>2\<^sub>A mem\<^sub>2\<^sub>A c\<^sub>2\<^sub>C mem\<^sub>2\<^sub>C c\<^sub>2\<^sub>A' mem\<^sub>2\<^sub>A'. 
         (\<langle> c\<^sub>1\<^sub>A, mds\<^sub>A, mem\<^sub>1\<^sub>A \<rangle>\<^sub>A, \<langle> c\<^sub>2\<^sub>A, mds\<^sub>A, mem\<^sub>2\<^sub>A \<rangle>\<^sub>A) \<in> \<R>\<^sub>A \<and>
         (\<langle> c\<^sub>2\<^sub>A, mds\<^sub>A, mem\<^sub>2\<^sub>A \<rangle>\<^sub>A, \<langle> c\<^sub>2\<^sub>C, mds\<^sub>C, mem\<^sub>2\<^sub>C \<rangle>\<^sub>C) \<in> \<R> \<and>
         (\<langle> c\<^sub>1\<^sub>C, mds\<^sub>C, mem\<^sub>1\<^sub>C \<rangle>\<^sub>C, \<langle> c\<^sub>2\<^sub>C, mds\<^sub>C, mem\<^sub>2\<^sub>C \<rangle>\<^sub>C) \<in> P \<and>
         abs.neval \<langle> c\<^sub>2\<^sub>A, mds\<^sub>A, mem\<^sub>2\<^sub>A \<rangle>\<^sub>A n \<langle> c\<^sub>2\<^sub>A', mds\<^sub>A', mem\<^sub>2\<^sub>A' \<rangle>\<^sub>A  \<longrightarrow>
           (\<exists> c\<^sub>2\<^sub>C' mem\<^sub>2\<^sub>C'. \<langle> c\<^sub>2\<^sub>C, mds\<^sub>C, mem\<^sub>2\<^sub>C \<rangle>\<^sub>C \<leadsto>\<^sub>C \<langle> c\<^sub>2\<^sub>C', mds\<^sub>C', mem\<^sub>2\<^sub>C' \<rangle>\<^sub>C \<and>
                   (\<langle> c\<^sub>2\<^sub>A', mds\<^sub>A', mem\<^sub>2\<^sub>A' \<rangle>\<^sub>A, \<langle> c\<^sub>2\<^sub>C', mds\<^sub>C', mem\<^sub>2\<^sub>C' \<rangle>\<^sub>C) \<in> \<R> \<and>
                   (\<langle> c\<^sub>1\<^sub>C', mds\<^sub>C', mem\<^sub>1\<^sub>C' \<rangle>\<^sub>C, \<langle> c\<^sub>2\<^sub>C', mds\<^sub>C', mem\<^sub>2\<^sub>C' \<rangle>\<^sub>C) \<in> P)))))"

definition
  secure_refinement_original :: "('Com\<^sub>A, 'Var\<^sub>A, 'Val) LocalConf rel \<Rightarrow> ('Com\<^sub>A, 'Var\<^sub>A, 'Val, 'Com\<^sub>C, 'Var\<^sub>C) state_relation \<Rightarrow> 
                          ('Com\<^sub>C, 'Var\<^sub>C, 'Val) LocalConf rel \<Rightarrow> bool"
where
  "secure_refinement_original \<R>\<^sub>A \<R> P \<equiv>
  closed_others \<R> \<and>
  preserves_modes_mem \<R> \<and>
  new_vars_private \<R> \<and>
  conc.closed_glob_consistent P \<and>
  coupling_inv_pres_original \<R>\<^sub>A \<R> P"

lemma "secure_refinement = secure_refinement_original"
  unfolding secure_refinement_def secure_refinement_original_def coupling_inv_pres_original_def
  by blast

(* Figure 1: Coupling invariant preservation *)

definition
  coupling_inv_pres_paper
where
  "coupling_inv_pres_paper \<B> \<R> \<I> \<equiv>
   \<forall> lc\<^sub>1\<^sub>A lc\<^sub>1\<^sub>C. (lc\<^sub>1\<^sub>A, lc\<^sub>1\<^sub>C) \<in> \<R> \<longrightarrow>
    (\<forall> lc\<^sub>1\<^sub>C'. lc\<^sub>1\<^sub>C \<leadsto>\<^sub>C lc\<^sub>1\<^sub>C' \<longrightarrow>
     (\<exists> n lc\<^sub>1\<^sub>A'. abs.neval lc\<^sub>1\<^sub>A n lc\<^sub>1\<^sub>A' \<and> (lc\<^sub>1\<^sub>A', lc\<^sub>1\<^sub>C') \<in> \<R> \<and>
       (\<forall>lc\<^sub>2\<^sub>A lc\<^sub>2\<^sub>C lc\<^sub>2\<^sub>A'. (lc\<^sub>1\<^sub>A, lc\<^sub>2\<^sub>A) \<in> \<B> \<and> lc\<^sub>1\<^sub>A =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2\<^sub>A \<and>
         (lc\<^sub>2\<^sub>A, lc\<^sub>2\<^sub>C) \<in> \<R> \<and> (lc\<^sub>1\<^sub>C, lc\<^sub>2\<^sub>C) \<in> \<I> \<and>
         lc\<^sub>1\<^sub>C =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2\<^sub>C \<and> abs.neval lc\<^sub>2\<^sub>A n lc\<^sub>2\<^sub>A' \<and> lc\<^sub>1\<^sub>A' =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2\<^sub>A' \<longrightarrow>
           (\<exists> lc\<^sub>2\<^sub>C'. lc\<^sub>2\<^sub>C \<leadsto>\<^sub>C lc\<^sub>2\<^sub>C' \<and> lc\<^sub>1\<^sub>C' =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2\<^sub>C' \<and>
             (lc\<^sub>2\<^sub>A', lc\<^sub>2\<^sub>C') \<in> \<R> \<and> (lc\<^sub>1\<^sub>C', lc\<^sub>2\<^sub>C') \<in> \<I>))))"

lemma coupling_inv_pres_paper_original:
  "coupling_inv_pres_paper = coupling_inv_pres_original"
  apply(rule ext)+
  apply(rename_tac \<B> \<R> \<I>)
  unfolding coupling_inv_pres_original_def coupling_inv_pres_paper_def abs.lc_same_mds_def conc.lc_same_mds_def
  by clarsimp

(* Definition 4: Closedness of refinements under changes by others *)

thm closed_others_def

(* Definition 5: Preservation of modes and memory *)

thm preserves_modes_mem_def

(* Definition 6: Requirements for secure refinement of the per-thread CVDNI property *)

definition
  secure_refinement_paper :: "('Com\<^sub>A, 'Var\<^sub>A, 'Val) LocalConf rel \<Rightarrow> ('Com\<^sub>A, 'Var\<^sub>A, 'Val, 'Com\<^sub>C, 'Var\<^sub>C) state_relation \<Rightarrow> 
                          ('Com\<^sub>C, 'Var\<^sub>C, 'Val) LocalConf rel \<Rightarrow> bool"
where
  "secure_refinement_paper \<B> \<R> \<I> \<equiv>
  preserves_modes_mem \<R> \<and> closed_others \<R> \<and>
  new_vars_private \<R> \<and> \<comment> \<open>In the paper, this is elided assuming no new shared vars\<close>
  conc.closed_glob_consistent \<I> \<and> sym \<I> \<and> coupling_inv_pres_paper \<B> \<R> \<I>"

(* This one is unidirectional because sym \<I> is not asserted directly by secure_refinement
  but rather by R\<^sub>C_of_strong_low_bisim_mm where it is used. *)
lemma secure_refinement_paper_original:
  "secure_refinement_paper \<B> \<R> \<I> \<Longrightarrow> secure_refinement \<B> \<R> \<I>"
  unfolding secure_refinement_paper_def
  apply(clarsimp simp:coupling_inv_pres_paper_original)
  unfolding coupling_inv_pres_original_def secure_refinement_def
  by blast
  
(* Theorem 5.1 of Murray_SPR_16 *)

definition
  \<B>\<^sub>C_of_paper :: 
 "((('Com\<^sub>A \<times> (Mode \<Rightarrow> 'Var\<^sub>A set)) \<times> ('Var\<^sub>A \<Rightarrow> 'Val)) \<times>
    ('Com\<^sub>A \<times> (Mode \<Rightarrow> 'Var\<^sub>A set)) \<times> ('Var\<^sub>A \<Rightarrow> 'Val)) set \<Rightarrow> 
  ('Com\<^sub>A, 'Var\<^sub>A, 'Val, 'Com\<^sub>C, 'Var\<^sub>C) state_relation \<Rightarrow>
  ((('Com\<^sub>C \<times> (Mode \<Rightarrow> 'Var\<^sub>C set)) \<times> ('Var\<^sub>C \<Rightarrow> 'Val)) \<times>
    ('Com\<^sub>C \<times> (Mode \<Rightarrow> 'Var\<^sub>C set)) \<times> ('Var\<^sub>C \<Rightarrow> 'Val)) set \<Rightarrow>
  ((('Com\<^sub>C \<times> (Mode \<Rightarrow> 'Var\<^sub>C set)) \<times> ('Var\<^sub>C \<Rightarrow> 'Val)) \<times>
    ('Com\<^sub>C \<times> (Mode \<Rightarrow> 'Var\<^sub>C set)) \<times> ('Var\<^sub>C \<Rightarrow> 'Val)) set"
where
  "\<B>\<^sub>C_of_paper \<B> \<R> \<I> \<equiv> {(x,y). \<exists>x\<^sub>A y\<^sub>A. (x\<^sub>A,x) \<in> \<R> \<and> (y\<^sub>A,y) \<in> \<R> \<and>
     (x\<^sub>A,y\<^sub>A) \<in> \<B> \<and> conc.lc_low_mds_eq x y \<and> (x,y) \<in> \<I>}"

lemma \<B>\<^sub>C_of_paper_R\<^sub>C_of:
  "\<B>\<^sub>C_of_paper = R\<^sub>C_of"
  unfolding R\<^sub>C_of_def \<B>\<^sub>C_of_paper_def conc.lc_low_mds_eq_def
  by fastforce

lemma \<B>\<^sub>C_of_paper_strong_low_bisim_mm:
  "abs.strong_low_bisim_mm \<B> \<and> secure_refinement_paper \<B> \<R> \<I> \<Longrightarrow>
   conc.strong_low_bisim_mm (\<B>\<^sub>C_of_paper \<B> \<R> \<I>)"
  apply clarsimp
  apply(frule secure_refinement_paper_original)
  unfolding secure_refinement_paper_def
  apply(clarsimp simp:\<B>\<^sub>C_of_paper_R\<^sub>C_of)
  using R\<^sub>C_of_strong_low_bisim_mm
  by force

(* Definition 8: Side-conditions for CVDNI-preserving refinement decomposition *)

definition
  decomp_refinement_safe_paper
where
  "decomp_refinement_safe_paper \<B> \<R> \<I> abs_steps \<equiv> \<forall> lc\<^sub>1\<^sub>A lc\<^sub>2\<^sub>A lc\<^sub>1\<^sub>C lc\<^sub>2\<^sub>C. (lc\<^sub>1\<^sub>A, lc\<^sub>2\<^sub>A) \<in> \<B> \<and>
   abs.lc_same_mds lc\<^sub>1\<^sub>A lc\<^sub>2\<^sub>A \<and> (lc\<^sub>1\<^sub>A, lc\<^sub>1\<^sub>C) \<in> \<R> \<and> (lc\<^sub>2\<^sub>A, lc\<^sub>2\<^sub>C) \<in> \<R> \<and> (lc\<^sub>1\<^sub>C, lc\<^sub>2\<^sub>C) \<in> \<I> \<and> lc\<^sub>1\<^sub>C =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2\<^sub>C \<longrightarrow>
       (stops\<^sub>C lc\<^sub>1\<^sub>C = stops\<^sub>C lc\<^sub>2\<^sub>C) \<and>
       (abs_steps lc\<^sub>1\<^sub>A lc\<^sub>1\<^sub>C = abs_steps lc\<^sub>2\<^sub>A lc\<^sub>2\<^sub>C) \<and>
       (\<forall>lc\<^sub>1\<^sub>C' lc\<^sub>2\<^sub>C'. lc\<^sub>1\<^sub>C \<leadsto>\<^sub>C lc\<^sub>1\<^sub>C' \<and> lc\<^sub>2\<^sub>C \<leadsto>\<^sub>C lc\<^sub>2\<^sub>C' \<longrightarrow> (lc\<^sub>1\<^sub>C', lc\<^sub>2\<^sub>C') \<in> \<I> \<and> lc\<^sub>1\<^sub>C' =\<^sub>m\<^sub>d\<^sub>s lc\<^sub>2\<^sub>C')"

lemma decomp_refinement_safe_paper:
  "decomp_refinement_safe_paper = simpler_refinement_safe"
  apply(rule ext)+
  unfolding decomp_refinement_safe_paper_def simpler_refinement_safe_def abs.lc_same_mds_def conc.lc_same_mds_def
  apply clarsimp
  by blast

(* Definition 7: Decomposed requirements for CVDNI-preserving secure refinement *)

definition
  secure_refinement_decomp_paper
where
  "secure_refinement_decomp_paper \<B> \<R> \<I> abs_steps \<equiv>
  preserves_modes_mem \<R> \<and> closed_others \<R> \<and>
  new_vars_private \<R> \<and> \<comment> \<open>In the paper, this is elided assuming no new shared vars\<close>
  conc.closed_glob_consistent \<I> \<and> sym \<I> \<and>
  decomp_refinement_safe_paper \<B> \<R> \<I> abs_steps \<and> (\<forall> lc\<^sub>A lc\<^sub>C. (lc\<^sub>A, lc\<^sub>C) \<in> \<R> \<longrightarrow>
    (\<forall> lc\<^sub>C'. lc\<^sub>C \<leadsto>\<^sub>C lc\<^sub>C' \<longrightarrow> (\<exists> lc\<^sub>A'. abs.neval lc\<^sub>A (abs_steps lc\<^sub>A lc\<^sub>C) lc\<^sub>A' \<and> (lc\<^sub>A', lc\<^sub>C') \<in> \<R>)))"

lemma secure_refinement_decomp_paper_simpler:
  "secure_refinement_decomp_paper \<B> \<R> \<I> abs_steps \<Longrightarrow> secure_refinement_simpler \<B> \<R> \<I> abs_steps"
  unfolding secure_refinement_decomp_paper_def
  apply(clarsimp simp:decomp_refinement_safe_paper)
  unfolding secure_refinement_simpler_def
  by blast

(* Theorem 9: Soundness of secure-refinement-decomp *)

lemma secure_refinement_decomp_paper_sound:
  "secure_refinement_decomp_paper \<B> \<R> \<I> abs_steps \<Longrightarrow> secure_refinement \<B> \<R> \<I>"
  using secure_refinement_decomp_paper_simpler secure_refinement_simpler
  by blast

end
